\chapter{Design}
\label{sec:design}

The goal of this project was to discover why VMAs sometimes do not merge even though it might be possible and to resolve such cases in as many situations as possible. In this part, we are going to summarize what decisions were made and what obstacles had to be overcome, including a detailed explanation of the final solution. This means everything from choosing the appropriate points of entry, verifying the conditions to implementing the actual changes including using already available solutions for partial problems.

\section{Analysis of the problem}
This section concentrates on where the problem is located and outlines the process necessary to solve it.

\subsection{What prevents merges}
\label{sec:what_prevents_merges}
When analysing the kernel code and specific cases in which merge does not happen for anonymous VMAs, even though it might, it comes down to these two main reasons.

\bigbreak

The first is the page offset, which is one of the parameters that has to be compatible in order to merge two VMAs. This makes perfect sense for memory mapped files, in which case it ensures that two parts of a single file represented by two individual VMAs can merge together only if the parts follow up and the resulting merged VMA would be one continuous file part. On the other hand, for anonymous mappings, dealing with the page offset is mostly just a side effect of using identical kernel mechanism for both anonymous and file mappings. When anonymous mapping is created, its page offset is identical to its virtual address with the page bits removed. This is fine until the mapping is moved to a new virtual address. In such a case in the current kernel, the page offset is updated only if the mapping has not been accessed by a process and therefore none of its pages have been faulted. In other cases, the page offset remains at the original value that does not correspond to its new virtual address. If two mappings are moved next to each other then this inconsistency prevents any possible merge even if all other conditions are met. This means that the first main change has to enable the update of the page offset when moving a mapping, which it turns out is not easy and for some cases sharing pages between processes not even possible.

\bigbreak

The second main reason is the \gls{av} to which the VMA belongs. In current kernel it is possible to merge only those VMAs that belong to identical AV. The most obvious reason why this is not allowed is that if such a merge would happen, it would mean updating all involved pages. This is necessary because every normal anonymous page stores a pointer to its AV in the \verb|mapping| property and this property would need to be updated during such a merge. This is complicated because traversing and locking pages during the merge process is not supported and most importantly the changes at the VMA, AV and page level should be done atomically at least from the \fullref{sec:rmap_walk} point of view. Allowing different AV merging does not only help when moving a mapping but also when the mapping is only modified in terms of flags or access protection in place e.g. in \verb|mprotect()| call.

\bigbreak

Moreover, these two reasons can apply simultaneously and so removing only one of them would yield fewer additional successful merges. And unfortunately both cases require update at the level of physical pages, which turns out to be problematic and probably the reason it has not been implemented yet. A detailed explanation is in dedicated sections for each of the problems.

\bigbreak

One last small identified problem preventing more merges is a missing\break \verb|vma_merge()| call in \verb|mremap()| when expanding an already existing mapping, in which case a merge might be possible with the following mapping. An overview of system calls potentially benefiting when the problems are resolved are summarized in \tableref{tbl:syscalls}.

\begin{table}[H]
\centering
\begin{tabular}{|p{4.4cm}|p{9.1cm}|}
\hline
 System call & Description \\ \hline \hline

\verb|mremap()[PAE]| & Expanding and/or moving an already existing mapping may relocate it next to another mapping and enable a merge. \\ \hline
\verb|mmap()[A]| & New mapping being created next to a compatible neighbouring mapping may result in a merge involving both its neighbours with potentially different AVs. \\ \hline
\verb|brk()[AE]| \break \verb|sbrk()[AE]| & Modifies the program break which can enlarge a mapping and enable a merge with a new neighbour. \\ \hline
\verb|mprotect()[A]| \break \verb|pkey_mprotect()[A]| & Modifies memory protection and therefore can unify the protection with a neighbouring mapping to enable a merge. \\ \hline
\verb|madvise()[A]| \break \verb|process_madvise()[A]| & Can in some cases modify flags of a mapping and this way unify the flags with a neighbouring mapping. \\ \hline
\verb|mlock()[A]| & Locks pages in the address range, which can unify flags with a neighbouring mapping. \\ \hline
\verb|mbind()[A]| & Sets memory policy for a memory range, which can unify flags with a neighbouring mapping. \\ \hline
\end{tabular}

\caption{Overview of system calls using vma\_merge() and their beneficial from resolving problems, page offset[P], different AV[A], expansion merge[E].}
\label{tbl:syscalls}
\end{table}


%\subsection{Callers of vma\_merge() and its mapping to cases}
%\begin{flushleft}
%\textbf{mmap\_region()} → expanding a mapping falls in cases 1 through 3 and merging of an already created vma falls in cases 6 through 8. In both vma\_merge() calls the anon\_vma is NULL, this means page→mapping update might happen only in cases 1 and 6 for the "next" VMA. \break
%\textbf{do\_brk\_flags()} → expanding a mapping falls in cases 1 through 3 as in mmap\_region() \break
%\textbf{mremap()} → expanding an already existing mapping falls in cases 1 through 3 as in mmap\_region() \break
%\textbf{mprotect\_fixup()} → flag change of an already existing vma, this means cases 6 through 8. %\break
%\textbf{userfaultfd\_release()} → same as mprotect\_fixup() \break
%\textbf{userfaultfd\_register()} → flag change of an already existing vma (cases 6 through 8) or a part of vma (cases 4 or 5). \break
%\textbf{userfaultfd\_unregister()} → same as userfaultfd\_register() \break
%\textbf{mlock\_fixup()} → same as userfaultfd\_register() \break
%\textbf{madvise\_update\_vma()} → same as userfaultfd\_register() \break
%\textbf{mbind\_range()} → same as userfaultfd\_register() \break
%\end{flushleft}


\subsection{Solution outline}

As mentioned in \fullref{sec:what_prevents_merges}, we have to update\break \verb|page→index| for individual pages involved in a \verb|mremap()| call and also\break \verb|vma→vm_pgoff| for the mapping itself to enable merges for mappings with faulted pages. Moreover, this update is necessary even when the \verb|mremap()| call does not result in a merge - this way, the page offset of the mapping is updated to enable a merge with another mapping that might become adjacent in the future. Details in \fullref{sec:offset_update}.

\bigbreak

To allow merging of VMAs with different AVs, it is necessary to perform an update of individual pages involved in the merge so that their \verb|page→mapping| points to the correct AV after the merge is done. The resulting AV is always the AV that belonged to one of the mappings at the beginning and so only pages of one of the mappings need to be updated. Details in \fullref{sec:diff_av}.

\bigbreak

Both approaches outlined above require an update of individual pages, which is problematic because if the pages are shared with another process, the update would interfere with the other process as well and could require a cascade of updates. This could get quite complicated and slow down the whole merge process. Therefore, when deciding to perform the update itself, we must first check if the pages are not shared, which is explained in \fullref{sec:checking_shared}, and if the pages are indeed shared, then we cannot proceed with the merge.

\bigbreak

An addition of a \verb|vma_merge()| call during expanding \verb|mremap()| is explained in \fullref{sec:mremap_expansion}.

\pagebreak

\section{Checking if VMA is shared}
\label{sec:checking_shared}
For every VMA that we want to modify either to update page offset or to assign it to a different \verb|anon_vma|, we have to check if its physical pages are not shared with other processes. If two VMAs usually in two different processes share the same physical pages, we say, these VMAs are shared. There are two approaches to effectively recognise this. The first one looks at the their \gls{av} structures that head a list of private related VMAs and searches for a parent-child relationship. The second approach goes through all the pages belonging to the VMA and checks their mapcount, which indicates in how many mappings the page is involved, however, this approach is more complicated and slower.

\subsubsection{AV checks}

In order to check if a VMA shares some pages with a different VMA from another process, we perform the parent check and the child check. Both are described in detail in \fullref{sec:detecting_parent_child_relationship} and work with an AV, where the parent check checks for a parent and the child check checks for children.

\bigbreak

\textbf{Parent check} is a simple comparison of AV and its root:\break \verb|vma→anon_vma→root == vma→anon_vma|. If it is the same object then there is no parent. But if it is two different objects, then the parent exists and we are looking at a shared scenario.

\bigbreak

\textbf{Child check} is complicated and involves traversing a red black tree of private related VMAs and their AVs from the original AV point of view. The check can be simplified by checking AV's degree, which is always higher than one in the shared scenario, but it is only an implication, not equivalence. Therefore if it is higher than one, normal checks must follow.

\subsubsection{Individual page checks}

Checking if an individual page is shared is a bit complicated, because the page might not be present in memory, can be swapped out or even worse, it can be swapped out for one process and not for the other ones.
\bigbreak
First, we check if the page is not swapped out in this process by looking at the PTE's swapped bit, which indicates if the PTE is actually a PTE or rather a swap entry. For the case of swap entry, we check the swap map, which holds a number of references that basically indicates how many processes reference this page in a swapped out state. It is not so simple though as there are also some flag bits stored in the same variable, but fortunately we only want to check if the page is shared or not and therefore basically anything bigger than one means the page is shared. This is true because both flags imply that the page is shared somehow. The first flag, \verb|SWAP_HAS_CACHE| with value \verb|0x40|, indicates that the swap cache is active. This means that for some processes the page is mapped and for some it is not, which inherently implies the page is involved with more than one process and therefore shared. The second flag is \verb|COUNT_CONTINUED| and indicates that the reference count is too high to fit in only one instance of the variable. This again implies the page is necessarily shared. See \fullref{sec:swap_cache} for more details. 
\bigbreak
In the other case, when the PTE is not swapped out and we can access the page structure, we call functions \verb|page_mapcount()| and \verb|page_swapcount()|, which give us the number of processes that map this page and the number of processes that have this page swapped out. The sum of these two is the total number of processes that use this page and therefore if it is higher than one then the page is shared.
\bigbreak
In both cases, we use the page walk with flags \verb|WALK_MIGRATION| and\break \verb|WALK_LOCK_RMAP| to go through all the necessary pages. These two flags ensure that the page is not in the migration entry state where we would not be able to access the above-mentioned parameters. If the page is in the migration entry state, then the page walk first waits for the migration to end and afterwards takes locks preventing new migration from starting until all checks are finished.

%\subsection{Page update}

%Page can be part of swap cache when it is being swapped out. In this case, it is best to wait for the process to finish, this is ensured by locking the page, which effectively waits for the swapping to end.

\pagebreak

\section{Detecting parent-child relationship in AV trees}
\label{sec:detecting_parent_child_relationship}

Shared physical pages in case of anonymous mappings can always belong to only one \gls{av} through their \verb|page→mapping| parameter, which in this case holds a pointer to the AV in question. On the other hand, each VMA can have several AVs, but one of them is always the main one and is accessible through \verb|vma→anon_vma|. Sharing usually happens because of forking and the underlying \gls{cow} mechanism. Only the original VMA has its main AV identical to the AV of all of its pages. Copies of the VMA in other processes have several AVs and the one used by the shared pages is one of the other AVs, the main one is used only for new pages that come into being when the VMA copy is enlarged or when the shared pages are to be written and have to be copied. These new pages are then exclusively owned by this VMA copy and their AV matches the main AV of the VMA copy.

\bigbreak

The reason why the child VMAs have additional AVs is because the shared pages are gradually replaced with new ones that can belong to a different AV rather than the original AV, which would otherwise keep growing and unrelated pages would unnecessarily belong to a single huge AV.

\FloatBarrier
\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/anon_vma_parent_child_success.png}
  \caption{Finding two different main AVs.}
  \label{fig:av_parent_child_success}
\end{figure}

\FloatBarrier

The task of detecting the parent-child relationship means that we get a VMA and must determine if it is sharing its pages with other processes. This is done by taking its main AV and then going through all the VMAs related to this AV. If any of these related VMAs have a different main AV from the given one, then we have a parent-child relationship and therefore an instance of page sharing. This process is demonstrated in \figureref{fig:av_parent_child_success}, the individual steps are highlighted by different colors and their order can be seen in \figureref{fig:av_legend}. More details about AVCs can be found in \fullref{sec:anon_vma_chain}. 

\begin{figure}[H]
  \includegraphics[width=\linewidth]{../img/anon_vma_legend.png}
  \caption{Phases of detecting parent-child relationship.}
  \label{fig:av_legend}
\end{figure}

\FloatBarrier
\bigbreak


If all these AVs of the related VMAs are identical to the original one, then we have a group of VMAs all associated with the same AV, but not sharing any pages. This is the case e.g. when we split an existing mapping into two or create two adjacent mappings that have different flags (if the flags were the same, they would merge). An example can be seen in \figureref{fig:av_siblings}.
\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/anon_vma_siblings.png}
  \caption{Sibling VMAs associated with the same AV.}
  \label{fig:av_siblings}
\end{figure}
\FloatBarrier



The entry point through the given VMA is \verb|vma→anon_vma| and then through \verb|anon_vma→rb_root|. The red-black tree is a tree of AVCs, which is a structure connecting an AV and a VMA. Nonetheless, we can easily get VMA through AVC by \verb|avc→vma| and then its main AV by \verb|vma→anon_vma|.

\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/anon_vma_parent_child_failure.png}
  \caption{Finding only one main AV.}
  \label{fig:av_parent_child_failure}
\end{figure}
This whole mechanism works only in the case where the given VMA is the parent VMA, as can be seen in \figureref{fig:av_parent_child_failure}. If the given VMA is a child VMA in a parent-child relationship then we determine this by accessing its main AV and then by checking if this AV has a root AV different from itself, as can be seen in \figureref{fig:av_parent_child_root_success}, \figureref{fig:av_parent_child_root_failure} and \figureref{fig:av_parent_child_root_legend}. This is actually much easier and it is done simply by \verb|vma→anon_vma→root|. Unfortunately, we do not know if we are looking at a child or a parent and therefore we do both checks.


\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/anon_vma_parent_child_root_success.png}
  \caption{Detecting parent-child relationship from child.}
  \label{fig:av_parent_child_root_success}
\end{figure}
\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/anon_vma_parent_child_root_failure.png}
  \caption{Trying to detect parent-child relationship from parent using the root method.}
  \label{fig:av_parent_child_root_failure}
\end{figure}
\begin{figure}[H]
  \center
  \includegraphics[width=250px]{../img/anon_vma_parent_child_root_legend.png}
  \caption{Phases of detecting parent-child relationship via root method.}
  \label{fig:av_parent_child_root_legend}
\end{figure}

\FloatBarrier

More detailed schemas showing even support structures are demonstrated on a child with a parent and a grandparent. \figureref{fig:avc_grandparent} gives the grandparent point of view and \figureref{fig:avc_grandchild} gives the the grandchild point of view.

\begin{figure}[H]
  \center
  \includegraphics[width=\linewidth]{../img/anon_vma_detailed_grandparent.png}
  \caption{AVC tree traversal from grandparent.}
  \label{fig:avc_grandparent}
\end{figure}

\begin{figure}[H]
  \center
  \includegraphics[width=\linewidth]{../img/anon_vma_detailed_grandchild.png}
  \caption{AVC tree traversal from grandchild.}
  \label{fig:avc_grandchild}
\end{figure}

\FloatBarrier

\pagebreak

\section{Common helper functions}

\subsubsection{KSM impact}

As mentioned in Analysis, KSM is a page de-duplication mechanism. As a result, mapcount of a de-duplicated page can be higher than mapcount of a normal page, which would interfere with the page checks trying to determine if the page is shared or not. Fortunately, in the case of the page offset update, KSM is always disabled in \verb|move_vma()| for the given area by a \verb|madvise()| call that sets the area to \verb|MADV_UNMERGEABLE|. This temporarily duplicates all the pages in question, but allows for KSM to merge the pages again after \verb|mremap()| is done.
\bigbreak
On the other hand, in the case of merging two VMAs with different AVs their pages might be in the de-duplicated KSM state. This will prevent the change of \verb|page→mapping| (holding the AV) that has to be updated during the merge. But fortunately when they return to normal state, their \verb|page→mapping| will be reconstructed from their VMA, which will already hold the possibly updated pointer to its AV.

\subsection{Pagewalk flags}

The pagewalk mechanism did not have a flags mechanism that would be able to perform predefined special operations like locking if a flag is specified. Although the \verb|action| feature is somewhat similar, it does not perform any action on its own. It only instructs the pagewalk core to repeat or skip user-defined table entry operations.
\bigbreak
Two flags were added. The first one for locking rmap locks to prevent rmap walk from interfering with the page update action, which could cause failure to find the correct VMA for the page. The second one for enabling migration waiting. Each PTE can be in the state of migration, which is determined by checking if PTE contains a migration entry instead of a normal PTE. Waiting for the migration means the page walk must unlock locks needed for migrations and lock them again after the migration has ended.

%Alternative text
%Following patches need to wait for migration and take rmap locks before
%    they work with the pte itself. This feature is a compact change and is
 %   therefore extracted into this patch.
  %  
   % In order to wait for migration when a page is being migrated, new flag
    %is added to pagewalk to optionally enable waiting for migration at the
%    walk_pte_range_inner() level. Similar flag was added to take rmap locks
 %   at the same level.
  %  
   % When waiting for migration pte lock and rmap locks must be dropped and
%    taken again after the migration has ended. Similar mechanism is taken if
 %   pte_entry() sets ACTION_AGAIN, which happens in the following patch when
  %  a deadlock is encountered, because of a different lock order used during
   % the page update.
    
%    Migration waiting is done only at the PTE level and is presumes no pmd
 %   entry is specified. If pmd_entry() is set together with page migration
  %  flag a warning is logged. PMD migration waiting can implemented later if
   % anyone needs it.
    
%    At this time flags can be specified only by calling walk_page_vma(). If
 %   needed flags can also be added to other pagewalk API calls.


\section{Development history}

During the analysis and development, there were several solutions that turned out not to work or at least not to work well enough and had to be redone. This was mostly because some problems were quite specific and hard to discover and of course because of inadequate documentation. This prolonged the whole development process.

\bigbreak

There are three more or less working historical versions of the patches located in the attachment's \verb|sources/history| directory that can serve as checkpoints along the development history described in this section.

\subsubsection{Only pgoff update}

The original idea for a solution was to only add the updating of the page offset when the mapping is moved and this way enable new merges in \verb|mremap()|. This was promising until tracing was added to measure the number of successful merges, then it turned out that most of the merges were still not happening because of different \gls{av}s.

\subsubsection{Not updating pages}

The next problem was that updating the page offset only in the VMA was not enough, although it worked in most of the cases and the system seemed to work more or less properly. Unfortunately, the inconsistency between the offset in VMA and in the page itself causes problems when swapping out the page in question. Therefore updating of page offset stored in \verb|page→index| was added.

\subsubsection{Adding AV update}
As mentioned above, the difference between AVs of the two VMAs we are trying to merge prevents the merge. This can be solved by allowing such merges and then reassigning pages from one AV to another. This allows additional merges not only in the case of the \verb|mremap()| calls, but also and even in greater number in the case of the \verb|mprotect()| calls and other calls that do not move the mapping but only change its flags.

\subsubsection{Using follow page instead of page walk}
Originally, when accessing pages that should be updated, \verb|follow_page()| was used. The disadvantage of this approach is that \verb|follow_page()| internally performs a full page table walk before it returns the page mapped at the given address. This is especially a problem when going through higher numbers of pages at the same time. \verb|follow_page()| was therefore replaced using the page walk framework\footnote{as implemented in mm/pagewalk.c}, which allows going through several PTEs (which point to a page) at a time and saves some unnecessary page walking.

\subsubsection{Pgoff update moved to move\_page\_tables()}
Using the page walk is much better than the \verb|follow_page()| call, but in the case of page offset update, it is even better to do the page update in\break \verb|move_page_tables()|, which moves all the page tables anyway. This again saves some extra traversing time.

\subsubsection{Transparent huge pages}
A problematic case is when the VMA does not map normal physical pages but instead transparent huge pages that are basically bigger blocks of pages. Eventually, to avoid additional complexity, THPs are split and then processed as normal pages.

\subsubsection{Added waiting for migration if we have migration entry}
When working with the PTEs, occasionally a PTE might be either in the swap entry or the migration entry state. In the case of the swap entry, we can access reference counts or swap cache to acquire the number of processes mapping the page. Furthermore, during the page update itself, we do not need to do anything as the mapping and the index are reconstructed from the VMA when the page is swapped back in. More problematic is the case when PTE holds a migration entry, which does not provide the needed information and cannot be updated. In this case, it is necessary to wait for migration to finish and unlock locks preventing the migration from finishing.

\subsubsection{Added rmap walk locks to not race with rmap walk}
When updating a page, the rmap locks have to be taken to prevent rmap walk running at the same time. Otherwise the rmap walk might partially work with the old page data and partially with the new page data.

\subsubsection{Redone AV update}
The \verb|anon_vma| update in \verb|vma_adjust()| had to be redone as it was inherently wrong and was updating only some of the necessary cases. Now the update is done in \verb|vma_adjust()| only for the \verb|mprotect()| cases and in \verb|move_page_tables()| for moving \verb|mremap()| cases (together with page offset update). Although this was quite a big issue, the related bugs and failures occurred only sporadically and were hard to reproduce or pinpoint.

\subsubsection{Pgoff update at the lowest level possible}
Pgoff update in \verb|move_page_tables()| has to be done at the lowest level to ensure correct locking order of page lock, rmap locks and PTE lock. A similar thing has to be done for all the other page walks that have a wrong locking order. This is achieved by try-locking instead of locking pages and if needed again unlocking all previous locks and retrying the step via the \verb|ACTION_AGAIN| directive in page walk mechanism.

\pagebreak

\section{Refactoring vma\_merge()}
\label{sec:refactor_vma_merge}

The first reason for this refactor is to make the function suitable for tracing of successful merges that are made possible by \fullref{sec:offset_update}, \fullref{sec:diff_av} and \fullref{sec:mremap_expansion}. 
The second reason is to make it shorter and more understandable by eliminating code duplicity and unnecessary indentation mainly in the case of merge next check. This is done by first doing checks and caching the results before executing the specific merge case itself. Exit paths are also unified.

\section{Page offset update}
\label{sec:offset_update}

This first change adjusts page offset of a VMA when it's moved to a new location by \verb|mremap()|, which is only possible for VMAs that do not share their anonymous pages with other processes. It is checked by going through the AV tree and looking for parent-child relationship as described in \fullref{sec:checking_shared}. %Also and probably redundantly this is checked for individual struct pages belonging to the given vma by looking at their mapcount or swap entry reference count if the page is swapped out, but the check is only in a form of a warning.
Also if the VMA contains any transparent huge pages, they are split to avoid dealing with them. This is all done in functions \verb|can_update_faulted_pgoff()| and \verb|is_shared_pte()|. At the start, the situation may look like in \figureref{fig:pgoff_update_01}. 
\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_update_01.png}
  \caption{At the start we have two VMAs with an unmapped space between them. The right VMA is to be moved next to the left one and merged.}
  \label{fig:pgoff_update_01}
\end{figure}

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_update_02.png}
  \caption{VMA copy merged with its new neighbour. Old VMA B is still present.}
  \label{fig:pgoff_update_02}
\end{figure}

If none of the pages is shared then we proceed with the page offset update. This means updating page offset in \verb|copy_vma()|, which is then used when creating a copy of the VMA or possibly when deciding whether to merge with a neighbouring VMA as seen in \figureref{fig:pgoff_update_02}, where the copy is already merged with its new neighbour. We also set \verb|update_pgoff| to true to later update page offsets of individual pages that are moved as seen in \figureref{fig:pgoff_update_03}. This is done in \verb|move_page_tables()| when moving individual PTE entries to the target VMA. The page offset update actually forces the move to happen at the PTE level by using function \verb|move_ptes()|. It is necessary to perform the move at the lowest possible level, because the page update must happen atomically with the move and that is not possible when moving bigger entries like PMD or PUD. 


\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_update_03.png}
  \caption{Update of page offset of individual pages. Pages in figure are moved only symbolically.}
  \label{fig:pgoff_update_03}
\end{figure}
\bigbreak

We do not need to update swapped out pages, because in that case the page offset is reconstructed automatically from the VMA after the page is swapped back in. As mentioned above, there is a small amount of time between checking and actually updating the page offset of the pages, as well as between merging VMAs and again updating the pages. This could potentially interfere with rmap walk, however, in that case rmap walk will still use the existing old VMA, as it would before the \verb|mremap()| started. Any other potential changes to the VMA or pages apart from rmap walk are prevented by \verb|mmap_lock|, which prevents forking and therefore also COW and hence creating any copies and therefore sharing during the merge process. Keeping in mind that pages are not shared and belong to only one process, there is no other process which might fork and in that way create a copy of the pages in question. However, if a page is shared, we can't update page offset of that page, because that would interfere with the page offset as seen from the other processes using the same page. Page offset is basically immutable as long as the page is used by more than one process. Previously, adjusting page offset was possible only for not yet faulted VMAs, even though page offset matching the virtual address of the anonymous VMA is necessary to successfully merge with another VMA. 
\bigbreak
In the end, when the page offset update results in a successful merge, then the old VMA structure can be freed as is seen in \figureref{fig:pgoff_update_04}.

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_update_04.png}
  \caption{Removing old VMA after successful merge.}
  \label{fig:pgoff_update_04}
\end{figure}


\section{Different AV merging}
\label{sec:diff_av}

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_and_av_update_01.png}
  \caption{Before pgoff and AV update merge.}
  \label{fig:pgoff_and_av_update_01}
\end{figure}

The goal of this change is to enable merging of a VMA even when it is linked to a different AV than the VMA it is being merged to, however, only if the VMA in question does not share any pages with a parent or child process. This enables merges that would otherwise not be possible and therefore decreases the number of VMAs of a process. The initial state can look like in \figureref{fig:pgoff_and_av_update_01} or in \figureref{fig:av_update_01} depending on the relative position of the VMAs.

\bigbreak
\begin{figure}[H]
  \center
  \includegraphics[width=225px]{../img/av_update_01.png}
  \caption{Before AV update merge.}
  \label{fig:av_update_01}
\end{figure}
    
The VMA in question is first checked at the level of AV to find out if it shares any pages with a parent or child process, see \fullref{sec:detecting_parent_child_relationship}. This check is performed in \verb|is_mergeable_anon_vma()|, which is a part of \verb|vma_merge()|. 
%In this case it is not easily possible to check mapcount of individual pages (as opposed to previous commit "mm: adjust page offset in mremap"), because vma_merge() does not have a pointer to the VMA or any other means of easily accessing the page structures.    
In the following two paragraphs we are using cases 1 through 8 as described in comment before \verb|vma_merge()|, which can be seen in \figureref{fig:vma_merge_comment}.

\begin{figure}[H]
  \center
  \includegraphics[width=\linewidth]{../img/vma_merge_comment.png}
  \caption{vma\_merge() comment.}
  \label{fig:vma_merge_comment}
\end{figure}

\bigbreak

For cases 4 through 8 and partially for case 1, the update itself is done\break in \verb|__vma_adjust()|. Other cases must be solved elsewhere, because\break \verb|__vma_adjust()| can only work with pages that already reside in the location of the merge, in other words if VMA already exists in the location where merge is happening. This points to the cases 2, 3 (and partially case 1 where the next VMA is already present but the middle one is not), which happen when we are either expanding or moving a VMA to the location of the merge. However, at the time of the merge, the VMA is not there yet and therefore the page update has to be done later elsewhere as there is no way how to access the pages in \verb|__vma_adjust()|. 

\bigbreak

An easy subcase is if the pages do not exist yet and therefore there is nothing to update. This happens e.g. when expanding a mapping in \verb|mmap_region()| or in \verb|do_brk_flags()|, where the pages themselves are created later.

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_and_av_update_02.png}
  \caption{Merging copy of the VMA with its new neighbour.}
  \label{fig:pgoff_and_av_update_02}
\end{figure}

\bigbreak

On the other hand, during a \verb|mremap()| call that moves an already existing and possibly faulted mapping, the pages do exist and have to be updated. The VMA is first copied in \verb|copy_vma()| to the target location and possibly merged with a new neighbour in \verb|__vma_adjust()| as shown in \figureref{fig:pgoff_and_av_update_02}. In this case, the page update is done in \verb|move_page_tables()|. It is actually quite simple because we already introduced page update in \fullref{sec:offset_update} and therefore the only change is updating one more parameter as seen in \figureref{fig:pgoff_and_av_update_03} compared to \figureref{fig:pgoff_update_03}. If rmap walk happens between \verb|__vma_adjust()| and page update in \verb|move_page_tables()|, then the old VMA and the old AV are used as it would happen before starting the whole merge, afterwards the new (merged) VMA and AV is used.
\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_and_av_update_03.png}
  \caption{Page offset and AV update. Pages in figure are moved only symbolically.}
  \label{fig:pgoff_and_av_update_03}
\end{figure}

Let's get back to the cases 4 through 8. These cases correspond to merges which are a result of a \verb|mprotect()| call or any other flag update that does not move or resize the mapping. The partial result of such a merge on the level of VMAs can be seen in \figureref{fig:av_update_02}, where the future VMA is already expanded, but the old one is also still existing. Together with a part of the case 1, the update of physical pages is handled directly here in \verb|__vma_adjust()| as mentioned before. First, it is determined which address range should be updated depending on the specific case 1, 4, 5, 6, 7 or 8. %The address range is set to variables \verb|pu_start| and \verb|pu_end|.
Second, the AV value to be set to the \verb|page->mapping| must be determined. However, it is always the AV belonging to the \verb|expand| parameter of the \verb|__vma_adjust()| call.

\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=225px]{../img/av_update_02.png}
  \caption{Future VMA enlarged but the old is still existing.}
  \label{fig:av_update_02}
\end{figure}

The reason we have to update the pages is that in \verb|__vma_adjust()|, the ranges \verb|vm_start| and \verb|vm_end| are updated for involved VMAs and so pages can belong to different VMA and AV from that point on. 

\bigbreak


The problem is that these two updates (VMAs and pages) should happen atomically from the rmap walk point of view. This would normally be solved by using rmap locks, but at the same time, we must keep in mind that the page migration uses rmap walk at the start and at the end and so rmap locks might trap the migration in the middle. This would cause a PTE to not point to any actual page and remain in the migration entry state, which would block the page update. The solution is to page walk all the relevant pages, if necessary drop rmap locks for time needed to allow page migration to end and update the \verb|page->mapping| (i.e. the AV) attribute of each page.

\bigbreak

This whole page update must be done after the \verb|expand| VMA is already enlarged, but the source VMA still has its original range as seen in \figureref{fig:av_update_03}. This way if rmap walk starts while we are updating the pages, it will work either with the old or the new AV and therefore also the old or new VMA. 

\begin{figure}[H]
  \center
  \includegraphics[width=225px]{../img/av_update_03.png}
  \caption{Reassigning pages to the new AV.}
  \label{fig:av_update_03}
\end{figure}

\bigbreak

If the PTE is a swap entry or points to the zero page or a KSM page, then the page is not updated and the correct mapping is reconstructed from the VMA itself when the page returns to normal state. Again as mentioned and explained in \fullref{sec:offset_update}, the pages may not become shared between \verb|vma_merge()| checks and actually merging in \verb|__vma_adjust()| as potential fork is prevented by \verb|mmap_lock|. Additionally, in the case where one of the VMAs is not yet faulted and therefore does not have an AV assigned, this change is not needed and merge happens even without it.

\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=300px]{../img/pgoff_and_av_update_04.png}
  \caption{Removing old VMA and AV (when it is unused).}
  \label{fig:pgoff_and_av_update_04}
\end{figure}

In the end, the old AV and possibly VMA is freed as seen in \figureref{fig:pgoff_and_av_update_04} and \figureref{fig:av_update_04} for the relevant cases.

\bigbreak

\begin{figure}[H]
  \center
  \includegraphics[width=225px]{../img/av_update_04.png}
  \caption{Removing old VMA and AV (when it is unused).}
  \label{fig:av_update_04}
\end{figure}

\section{Allowing merge during mremap() in-place expansion}
\label{sec:mremap_expansion}

When \verb|mremap()| call results in an in place expansion, it might be possible to merge the VMA with the next VMA if it becomes adjacent. The only missing part is a \verb|vma_merge()| call after the expansion is done to try and merge.

\section{Tracing}

A new tracepoint was added to measure how many successful merges were made because of these changes and which change or changes in particular made the merge possible. There are three different changes and therefore also three different tracing categories.

\subsection{AV merging}

A trace support was added to \verb|vma_merge()| to measure successful and unsuccessful merges of two VMAs with distinct AVs as well as the reason why the merge was successful or unsuccessful using the \verb|vma_merge_res| enum as can be seen in the \tableref{tbl:merge_attempt_results}.

\begin{table}[H]
\centering
\begin{tabular}{|p{4cm}|p{9.5cm}|}
\hline
 Name & Description \\ \hline \hline

\verb|MERGE_FAILED| & Merge failed for other reasons than the AV.\\ \hline
\verb|AV_MERGE_FAILED| & Merge failed because one of the VMA is shared and the AVs are different.\\ \hline
\verb|AV_MERGE_NULL| & Merge is allowed because one of the AV is null.\\ \hline
\verb|MERGE_OK| & Equal to \verb|AV_MERGE_NULL|. Implementation detail.\\ \hline
\verb|AV_MERGE_SAME| & Merge is allowed because the AVs are identical.\\ \hline
\verb|AV_MERGE_DIFFERENT| & Merge is allowed even though the AVs are different.\\ \hline
\end{tabular}
\caption{Overview of vma\_merge\_res enum values.}
\label{tbl:merge_attempt_results}
\end{table}

\subsection{Page offset merging}
Trace support was added to \verb|copy_vma()| to measure successful merges made possible by an update of the page offset.

\subsection{In place expand merge}

Trace support was added to \verb|mremap()| to measure successful merges made possible by the added \verb|vma_merge()| call.



